package wtf.hak.survivalfabric.mixin.client;

import net.minecraft.block.enums.CameraSubmersionType;
import net.minecraft.client.render.BackgroundRenderer;
import net.minecraft.client.render.Camera;
import net.minecraft.client.render.Fog;
import net.minecraft.client.render.FogShape;
import net.minecraft.world.World;
import org.joml.Vector4f;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

import static wtf.hak.survivalfabric.config.client.ClientConfigManager.getConfig;

@Mixin(value = BackgroundRenderer.class, priority = 910)
public abstract class BackgroundRendererMixin {

    @Inject(method = "applyFog", at = @At("RETURN"), cancellable = true)
    private static void applyFog(Camera camera, BackgroundRenderer.FogType fogType, Vector4f color, float viewDistance, boolean thickenFog, float tickProgress, CallbackInfoReturnable<Fog> cir) {
        boolean renderFog = true;
        CameraSubmersionType subType = camera.getSubmersionType();
        if(subType == CameraSubmersionType.NONE) {
            World world = camera.getFocusedEntity().getWorld();
            if(world.getRegistryKey() == World.OVERWORLD && !getConfig().renderOverworldFog)
                renderFog = false;
            else if(world.getRegistryKey() == World.NETHER && !getConfig().renderNetherFog)
                renderFog = false;
            else if(world.getRegistryKey() == World.END && !getConfig().renderEndFog)
                renderFog = false;
        } else if(subType == CameraSubmersionType.WATER && !getConfig().renderWaterFog)
            renderFog = false;
        else if(subType == CameraSubmersionType.LAVA && !getConfig().renderLavaFog)
            renderFog = false;
        else if(subType == CameraSubmersionType.POWDER_SNOW && !getConfig().renderSnowFog)
            renderFog = false;

        if(!renderFog)
            cir.setReturnValue(new Fog(-8.0f, 1_000_000.0F, FogShape.CYLINDER, 0,0,0,0));
    }
}
